Declare Function ExtractIcon Lib "Shell" (ByVal hInst As Integer, ByVal lpszExeFileName As String, ByVal nIconIndex As Integer) As Integer
Declare Function GetWindowWord Lib "User" (ByVal hWnd As Integer, ByVal nIndex As Integer) As Integer
Declare Function DrawIcon Lib "User" (ByVal hDC As Integer, ByVal x As Integer, ByVal y As Integer, ByVal hIcon As Integer) As Integer
Declare Function FindExecutable Lib "Shell" (ByVal lpszFile As String, ByVal lpszDir As String, ByVal lpszResult As String) As Integer
Declare Function GetPrivateProfileString Lib "Kernel" (ByVal lpApplicationName As String, ByVal lpKeyName As String, ByVal lpDefault As String, ByVal lpReturnedString As String, ByVal nSize As Integer, ByVal lpFileName As String) As Integer
Declare Function GetPrivateProfileInt Lib "Kernel" (ByVal lpApplicationName As String, ByVal lpKeyName As String, ByVal nDefault As Integer, ByVal lpFileName As String) As Integer
Declare Function WritePrivateProfileString Lib "Kernel" (ByVal lpApplicationName As String, ByVal lpKeyName As String, ByVal lpString As String, ByVal lplFileName As String) As Integer
Declare Function WinExec Lib "Kernel" (ByVal lpCmdLine As String, ByVal nCmdShow As Integer) As Integer
Declare Function WinHelp Lib "User" (ByVal hWnd As Integer, ByVal lpHelpFile As String, ByVal wCommand As Integer, dwData As Any) As Integer
Declare Function GetFileTitle Lib "COMMDLG.DLL" (ByVal lpszFile As String, ByVal lpszTitle As String, ByVal cbBuf As Integer) As Integer
Declare Sub VBSysAbout Lib "sysmenu.dll" (ByVal hWnd As Integer, ByVal bSwitch As Integer)
Declare Function ControlhWnd Lib "CTLHWND.DLL" (cntl As Control) As Integer
Declare Function SetHook Lib "HLPKEY.DLL" (ByVal hWnd As Integer) As Integer
Declare Sub RemoveHook Lib "HLPKEY.DLL" ()
Declare Sub FreeLibrary Lib "Kernel" (ByVal hLibModule As Integer)
Declare Function LoadLibrary Lib "Kernel" (ByVal lpLibFileName As String) As Integer

Function GetProgramIcon (ThePathName As String, TheWindow As Form, ThePicture As Control) As Integer
Dim wsys As String
wsys = Space$(255)
GetProgramIcon = FALSE
hWindow = TheWindow.hWnd
hInstance = GetWindowWord(hWindow, GWW_HINSTANCE)
hIcon = ExtractIcon(hInstance, ThePathName, 0)
If hIcon = 1 Then
    hIcon = ExtractIcon(hInstance, "progman.exe", 1)
Else
    If hIcon = FALSE Then
        hIcon = ExtractIcon(hInstance, "progman.exe", 8)
    End If
End If
If hIcon <> FALSE Then
    ThePicture.Cls
    r% = DrawIcon(ThePicture.hDC, 0, 0, hIcon)
    GetProgramIcon = TRUE
    ThePicture.AutoRedraw = FALSE
End If
End Function

Sub CenterForm (TheForm As Form)
cLeft% = (Screen.Width - TheForm.Width) / 2
cTop% = (Screen.Height - TheForm.Height) / 2
TheForm.Move cLeft%, cTop%
End Sub

Sub GetHelp (TheWindow As Form, HelpType As Integer, TheTag As Long)
Screen.ActiveForm.MousePointer = 0
helpfile$ = EXENAME + ".hlp"
If TheTag = 0 Then TheTag = -1
e% = WinHelp(TheWindow.hWnd, helpfile$, HelpType, ByVal TheTag)
End Sub

Sub GetPreferenceSize (TheWindow As Form)
TheString$ = Space$(255)
TheKey$ = RTrim$(TheWindow.caption) + " " + "coordinates"
r% = GetPrivateProfileString("preferences", TheKey$, " ", TheString$, 255, EXENAME + ".ini")
If Len(TheString$) = 0 Then
    CenterForm TheWindow
    Exit Sub
End If
TheLeft& = 0
TheTop& = 0
TheWidth& = 0
TheHeight& = 0
r1% = InStr(1, TheString$, " ")
r2% = InStr(r1% + 1, TheString$, " ")
r3% = InStr(r2% + 1, TheString$, " ")
r4% = InStr(r3% + 1, TheString$, " ")
If r4% = 0 And r3% > 0 Then r4% = Len(TheString$) + 1
TheLeft& = Val(Mid$(TheString$, 1, r1% - 1))
TheTop& = Val(Mid$(TheString$, r1% + 1, r2% - r1% - 1))
TheWidth& = Val(Mid$(TheString$, r2% + 1, r3% - r2% - 1))
TheHeight& = Val(Mid$(TheString$, r3% + 1, r4% - r3% - 1))
If TheWidth& > 0 And TheHeight& > 0 Then
    TheWindow.Top = TheTop&
    TheWindow.Left = TheLeft&
    TheWindow.Width = TheWidth&
    TheWindow.Height = TheHeight&
End If
End Sub

Sub SetPreferenceSize (TheWindow As Form)
TheKey$ = RTrim$(TheWindow.caption) + " " + "coordinates"
TheString$ = Format$(TheWindow.Left, "0000") + " " + Format$(TheWindow.Top, "0000") + " " + Format$(TheWindow.Width, "0000") + " " + Format$(TheWindow.Height, "0000")
r% = WritePrivateProfileString("preferences", TheKey$, TheString$, EXENAME + ".ini")
End Sub

Function GetPreferenceRun (TheKey As String) As String
Dim TheString As String
TheString = String$(255, 0)
r% = GetPrivateProfileString("MRU file", TheKey, " ", TheString, 255, EXENAME + ".ini")
GetPreferenceRun = Mid$(TheString$, 1, r%)
End Function

Sub LoadMRU (TheWindow As Form, ThePic As Control, TheLabel As Control, i As Integer)
s$ = GetPreferenceRun(Format$(i, "00"))
exe$ = UnstringEXE(s$)
file$ = UnstringFile(s$)
If IsValidFile(exe$) Then
    LASTINDEXUSED = LASTINDEXUSED + 1
    cl(LASTINDEXUSED).FindEXEName = exe$
    ThePic.Enabled = TRUE
    TheLabel.Enabled = TRUE
    e% = GetProgramIcon(exe$, TheWindow, ThePic)
    If IsValidFile(file$) Then
        cl(LASTINDEXUSED).FindFILEName = file$
        TheLabel.caption = FileNameOnly(file$)
        TheLabel.FontName = TheLabel.FontName
        TheLabel.FontSize = TheLabel.FontSize
    End If
End If
End Sub

Function UnstringEXE (TheString As String) As String
UnstringEXE = ""
If Len(TheString) = 0 Then Exit Function
r% = InStr(1, TheString, " ")
If r% = 0 Then
    UnstringEXE = TheString
    Exit Function
End If
UnstringEXE = Mid$(TheString, 1, r% - 1)
End Function

Function UnstringFile (TheString As String) As String
UnstringFile = ""
If Len(TheString) = 0 Then Exit Function
r% = InStr(1, TheString, " ")
If r% = 0 Then Exit Function
r% = r% + 1
UnstringFile = Mid$(TheString, r%, Len(TheString) - r% + 1)
End Function

Function IsValidFile (ThePath As String) As Integer
IsValidFile = FALSE
ff% = FreeFile
On Error Resume Next
Open ThePath For Input As ff%
If Err = 0 Or Err = 70 Then
    IsValidFile = TRUE
End If
Close ff%
End Function

Function MakePath (DirBox As Control, FileBox As Control) As String
If "\" = Mid$(DirBox.Path, Len(DirBox.Path), 1) Then
    MakePath = DirBox.Path + FileBox.FileName
Else
    MakePath = DirBox.Path + "\" + FileBox.FileName
End If
End Function

Function GetPreferenceMulti () As Integer
r% = GetPrivateProfileInt("preferences", "allow multiple starts", 0, EXENAME + ".ini")
If r% Then
    GetPreferenceMulti = TRUE
Else
    GetPreferenceMulti = FALSE
End If
End Function

Sub SetPreferenceMulti (OnOff As Integer)
s$ = Str$(OnOff)
r% = WritePrivateProfileString("preferences", "allow multiple starts", s$, EXENAME + ".ini")
End Sub

Function FileNameOnly (FullPath As String) As String
s$ = String$(255, 0)
e% = GetFileTitle(FullPath, s$, 255)
e% = InStr(1, s$, Chr$(0))
If e% = 0 Then
    FileNameOnly = RTrim$(s$)
    Exit Function
End If
FileNameOnly = Mid$(s$, 1, e% - 1)
End Function

Sub UnloadMRU ()
For i% = 0 To MAX_INDEX
    s$ = RTrim$(cl(i%).FindEXEName) + " " + RTrim$(cl(i%).FindFILEName)
    SetPreferenceRun Format$(i%, "00"), RTrim$(s$)
Next i%
End Sub

Sub SetPreferenceRun (TheKey As String, TheString As String)
r% = WritePrivateProfileString("MRU file", TheKey, TheString, EXENAME + ".ini")
End Sub

Function NullToSpace (NullString As String) As String
e% = InStr(1, NullString, Chr$(0))
If e% = 0 Then
    NullToSpace = RTrim$(NullString)
    Exit Function
End If
NullToSpace = Mid$(NullString, 1, e% - 1)
End Function

Function GetCommandLine (FileName As String) As String
Dim UFileName As String
UFileName = UCase$(FileName)
Dim TheEXE As String
TheEXE = Space$(255)
hInstance = FindExecutable(UFileName, "", TheEXE)
If hInstance < 33 Then
    GetCommandLine = ""
    Exit Function
End If
Uls$ = UCase$(NullToSpace(TheEXE))
If Uls$ = UFileName Then
    GetCommandLine = UFileName
    Exit Function
End If
TheEXE = Space$(255)
hInstance = FindExecutable(Uls$, "", TheEXE)
Uls$ = UCase$(NullToSpace(TheEXE))
GetCommandLine = Uls$ + " " + UFileName
End Function

Sub DropDups ()
d% = 0
hit% = FALSE
For i% = 0 To MAX_INDEX
    s$ = ""
    If Len(cl(i%).FindEXEName) > 0 Then s$ = cl(i%).FindEXEName
    If Len(cl(i%).FindFILEName) > 0 Then s$ = s$ + " " + cl(i%).FindFILEName
    hit% = FALSE
    For i2% = 0 To d%
        s2$ = ""
        If Len(dup(i2%).FindEXEName) > 0 Then s2$ = dup(i2%).FindEXEName
        If Len(dup(i2%).FindFILEName) > 0 Then s2$ = s2$ + " " + dup(i2%).FindFILEName
        If s$ = s2$ Then hit% = TRUE
    Next i2%
    If hit% = FALSE Then
        d% = d% + 1
        If d% > MAX_INDEX Then Exit For
        dup(d%).FindEXEName = cl(i%).FindEXEName
        dup(d%).FindFILEName = cl(i%).FindFILEName
    End If
Next i%
For i% = 0 To MAX_INDEX
    cl(i%).FindEXEName = dup(i%).FindEXEName
    cl(i%).FindFILEName = dup(i%).FindFILEName
Next i%
End Sub

Sub ClearDups ()
For i% = 0 To MAX_INDEX
    dup(i%).FindEXEName = ""
    dup(i%).FindFILEName = ""
Next i%
End Sub

